﻿using AutoMapper;
using BL.Config;
using BL.DTOs;
using BL.QueryObjects;
using DAL;
using DAL.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BL.Services
{
    public class PetService
    {
        private IMapper mapper = new Mapper(new MapperConfiguration(MappingConfig.ConfigureMapping));
        private PetQueryObject petQueryObject;
        private PetsDbContext dbContext;

        public PetService(PetsDbContext db)
        {
            dbContext = db;
        }
        public PetGetDto GetTest()
        {
            var myPet = new Pet { Id = 1, Name = "Peter", Age = 7, BirthCertificate = "lolxxx" };

            //return new PetGetDto
            //{
            //    Name = myPet.Name,
            //    Age = myPet.Age
            //};
            return mapper.Map<PetGetDto>(myPet);
        }

        public IEnumerable<PetGetDto> GetPetsWithName(string name)
        {
            petQueryObject = new PetQueryObject(mapper, dbContext);
            return petQueryObject.ExecuteQuery(new PetNameFilterDto() { Name = name, SortAscending = true }).Items;
        }


    }
}
