﻿namespace EFInfrastructure
{
    public class EFQueryResult<TEntity, TKey> where TEntity : IEntity<TKey>
    {
        public long TotalItemsCount { get; }
        public int? RequestedPageNumber { get; }
        public int PageSize { get; }
        public IEnumerable<TEntity> Items { get; }
        public bool PagingEnabled => RequestedPageNumber != null;

        public EFQueryResult(IEnumerable<TEntity> items, long totalItemsCount, int pageSize = 10, int? requestedPageNumber = null)
        {
            TotalItemsCount = totalItemsCount;
            RequestedPageNumber = requestedPageNumber;
            PageSize = pageSize;
            Items = items;
        }
    }
}
